searchNodes=[{"ref":"Mix.Tasks.Shapt.html","title":"Mix.Tasks.Shapt","type":"task","doc":"Prints help info for Shapt tasks. Doesn&#39;t accept parameters."},{"ref":"Mix.Tasks.Shapt.html#run/1","title":"Mix.Tasks.Shapt.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Shapt.Expired.html","title":"Mix.Tasks.Shapt.Expired","type":"task","doc":"This task verify if the toggles of the informed Module is expired. Parameters: --module or -m: Accepts one or more modules as parameter to verify the expired toggles. Modules are separated by a comma. --strict or -s: Instead of just returning the expired toggles. Example: mix shapt.expired -m MyToggles,MyFlippers mix shapt.expired -sm MyToggles"},{"ref":"Mix.Tasks.Shapt.Expired.html#run/1","title":"Mix.Tasks.Shapt.Expired.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Shapt.Template.html","title":"Mix.Tasks.Shapt.Template","type":"task","doc":"This task output the template of a configuration for a Module. The template type is defined by the Adapter configured in the module. Parameters: --module or -m(required): Accepts a module as parameter to output a template to it&#39;s adapter. --file or -f: Accepts a filename as parameter to write the template to. If it&#39;s missing, will outpout to terminal. Example: mix shapt.expired -m MyToggles mix shapt.expired -m MyToggles -f template.env"},{"ref":"Mix.Tasks.Shapt.Template.html#run/1","title":"Mix.Tasks.Shapt.Template.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Shapt.Adapter.html","title":"Shapt.Adapter","type":"behaviour","doc":"A behaviour that defines the basic callbacks that a Shapt Adapter needs to implement. This callbacks are just the very basic behavior that an adapter might have."},{"ref":"Shapt.Adapter.html#c:enabled?/2","title":"Shapt.Adapter.enabled?/2","type":"callback","doc":"Verifies if a given toggle is enabled true or false. This only gonna be used if ets_cache option is set to false. It receives the toggle_name() of the key being verified and the state() of the Genserver. It include all the state() because adapter configuration can be used by the adapter."},{"ref":"Shapt.Adapter.html#c:key_name/2","title":"Shapt.Adapter.key_name/2","type":"callback","doc":"Reiceves toggle_name() and toggle_opts and should return the representation of the toggle name the way the adapter understands it. This is used mainly because when ets_cache and ets_loaded are both set to true, the GenServer will bypass the need to use the adapter. Use the same value returned here to load the toggle in the load_all/1 function."},{"ref":"Shapt.Adapter.html#c:load_all/1","title":"Shapt.Adapter.load_all/1","type":"callback","doc":"Load all toggles current value to the ets table. Please make sure to enforce values are only boolean"},{"ref":"Shapt.Adapter.html#c:template/2","title":"Shapt.Adapter.template/2","type":"callback","doc":"Produces the template outputed by Mix.Tasks.Shapt.Template. It receives the toggles keywordlist and the adapter options and returns the binary representing the template."},{"ref":"Shapt.Adapter.html#t:state/0","title":"Shapt.Adapter.state/0","type":"type","doc":"State of the GenServer created in a module that uses Shapt. environment - this is a way for adapters to know in which environment they are running, in case releases are being used. ets - reference of the ets table created when ets_cache option is set to true. ets_loaded - says if ets has been loaded with load_all/1 execution. toggles - take a loot at toggles() adapter - Module that is configured as the adapter. adapter_opts - configuration for the adapter"},{"ref":"Shapt.Adapter.html#t:toggle_name/0","title":"Shapt.Adapter.toggle_name/0","type":"type","doc":"The name of toggle set in the Shapt config."},{"ref":"Shapt.Adapter.html#t:toggle_opts/0","title":"Shapt.Adapter.toggle_opts/0","type":"type","doc":"Toggle options configured at keyword list in the Shapt config. Common options are key_name and deadline. deadline is required for the mix task Mix.Tasks.Shapt.Expired. Custom Adapters can define more options."},{"ref":"Shapt.Adapter.html#t:toggles/0","title":"Shapt.Adapter.toggles/0","type":"type","doc":"Keyword list containing all toggle and toggle options config."},{"ref":"Shapt.Adapters.DotEnv.html","title":"Shapt.Adapters.DotEnv","type":"module","doc":""},{"ref":"Shapt.Adapters.Env.html","title":"Shapt.Adapters.Env","type":"module","doc":""},{"ref":"Shapt.Plug.html","title":"Shapt.Plug","type":"module","doc":"This plug provides two endpoints: GET that will that will return the current value of your toggles on runtime. POST that will reload the current value of your toggles on runtime. Those features work better when you&#39;re caching values on ets with the ets_cache option set as true. This can be configured with the options path and modules, like the example: plug(Shapt.Plug, path: &quot;/toggles&quot;, modules: [TestModule])"},{"ref":"Shapt.Plug.html#call/2","title":"Shapt.Plug.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"Shapt.Plug.html#init/1","title":"Shapt.Plug.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"usage.html","title":"Usage Guide","type":"extras","doc":"Usage Guide Once Shapt is one of his dependencies. You gonna need to create a feature toggle module: defmodule TestModule do use Shapt, adapter: [ prod: {Shapt.Adapters.Env, []} ], toggles: [ feature_x?: %{ force: true, key: &quot;MYAPP_FEATURE_X&quot;, deadline: ~D[2019-12-31] }, feature_y?: %{ deadline: ~D[2009-12-31] } ] end This module is a worker that you need to add to your supervision tree. Shapt will create the proper child_spec/1 and start_link/1 functions."},{"ref":"usage.html#options","title":"Usage Guide - Options","type":"extras","doc":"adapter: receives a keyword list of adapters by environment. toggles: receives a keyword list of toggles to be configured."},{"ref":"usage.html#default-configurations","title":"Usage Guide - Default configurations","type":"extras","doc":"If no adapter is provided Shapt gonna set by default, Shapt.Adapters.Env as the production adapter and Shapt.Adapters.DotEnv as develompment and test adapter. toggles option has no default values."},{"ref":"usage.html#provided-functions","title":"Usage Guide - Provided functions","type":"extras","doc":"Just by using Shapt you gonna have some extra functions on your feature toggle module: key_name/0 For each key in the toggles option keyword list you gonna have a fucntion that represents that feature toggle. From the example above you would have in TestModule the functions feature_x?/0 and feature_y?/0, those functions always return only true or false. toggle/2 Besides the key named functions you gonna have toggle/2. It can be used to evaluate the feature toggle and what to do when it&#39;s on or off. Some usage examples: # just returning values TestModule.toggle(:feature_x?, on: FeatureX, off: OldFeature) # applying functions that receive the same parameters TestModule.toggle(:feature_x?, env: [params, options], on: &amp;Feature.x/2, off: &amp;Feature.old/2) # applying functions with different parameters: TestModule.toggle(:feature_x?, on: {ModuleX, :function, [paramsx]}, off: {Module, :fuction, [params]}) In those two last examples we use the apply function, be aware of that when using this feature. So make sure that the env or the third element tuple is always a list which the size is the same as the provided function arity. expired?/1 It receives the name of a toggle and says if it&#39;s expired or not. enabled?/1 It receives the name of a toggle and says if it&#39;s enabled or not. expired_toggles/0 List all expired toggles output_template/0 Return the binary representing the template file generated by the Adapter. instance_name/0 By default instance_name/0 will always return nil. This function is overridable so when needed you can specified the behavior to determine which instance we are running. For the default Adapters provided here this function has no utility, but it gonna be useful for future Adapters."},{"ref":"usage.html#env-adapter","title":"Usage Guide - Env Adapter","type":"extras","doc":"Shapt.Adapters.Env will work directly with environment variables using the System.get_env/1. This is why the adapter doesn&#39;t receive any configuration."},{"ref":"usage.html#dotenv-adapter","title":"Usage Guide - DotEnv Adapter","type":"extras","doc":"Shapt.Adapters.DotEnv works with a .env file. If no option is provided it gonna try to read a .env file from the root of the mix project you&#39;re running. To provide a file you can set {Shapt.Adapters.DotEnv, [file: &quot;path/to/file.env&quot;]} on your adapter configuration."},{"ref":"usage.html#testing","title":"Usage Guide - Testing","type":"extras","doc":"Shapt is built having in mind that you probably gonna use Mox to write tests. By using Mox you only need mock enabled?/2 callback. You can have more info on Shapt.Adapter behaviour docs."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-0-2","title":"Changelog - v0.0.2","type":"extras","doc":"Make the toggle module a worker that needs to be attached to a supervision tree or started with start_link. Refactor Adapters to work with worker architeture. Add option to have ets cache for all adapters. Add instance_name function to be used on Consul adapters. Add reload and all_values functions and callbacks Add plug"},{"ref":"changelog.html#v0-0-1","title":"Changelog - v0.0.1","type":"extras","doc":"Initial Release"}]